import { checkMulti } from "./hooks/checkMulti";
import { setData } from "./hooks/setData";
import { runPerItem } from "./hooks/runPerItem";
export declare const hooks: {
    checkMulti: typeof checkMulti;
    setData: typeof setData;
    runPerItem: (actionPerItem: (item: any, context: import("@feathersjs/feathers").HookContext<any, import("@feathersjs/feathers").Service<any>>) => any, _options?: import("./types").HookRunPerItemOptions | undefined) => import("./types").ReturnAsyncHook;
};
export { checkMulti };
export { setData };
export { runPerItem };
import { debounceMixin, DebouncedStore } from "./mixins/debounce-mixin";
export declare const mixins: {
    debounceMixin: typeof debounceMixin;
    DebouncedStore: typeof DebouncedStore;
};
export { debounceMixin };
export { DebouncedStore };
export { addHook } from "./utils/addHook";
export { getPaginate } from "./utils/getPaginate";
export { isMulti } from "./utils/isMulti";
export { isPaginated } from "./utils/isPaginated";
export { mergeQuery } from "./utils/mergeQuery/index";
export { mergeArrays } from "./utils/mergeQuery/mergeArrays";
export { pushSet } from "./utils/pushSet";
export { setResultEmpty } from "./utils/setResultEmpty";
export { markHookForSkip } from "./utils/markHookForSkip";
export { filterQuery } from "./utils/filterQuery";
export { getItemsIsArray } from "./utils/getItemsIsArray";
export { shouldSkip } from "./utils/shouldSkip";
export * from "./types";
