import type { DebouncedFunc } from "lodash";
import type { Application, Id } from "@feathersjs/feathers";
import type { DebouncedFunctionApp, DebouncedStoreOptions } from "../../types";
export declare const makeDefaultOptions: () => DebouncedStoreOptions;
export declare class DebouncedStore {
    private _app;
    private _options;
    private _isRunningById;
    _queueById: Record<string, DebouncedFunc<((id: Id, action: DebouncedFunctionApp) => void | Promise<void>)>>;
    add: (id: Id, action: (app?: Application<{}> | undefined) => void | Promise<void>) => void | Promise<void> | undefined;
    constructor(app: Application, options?: Partial<DebouncedStoreOptions>);
    private unbounced;
    private debounceById;
    cancel(id: Id): void;
}
