import { filterQuery as plainFilterQuery } from "@feathersjs/adapter-commons";
export function filterQuery(query, options) {
    query = query || {};
    options = options || {};
    if (options?.service) {
        const { service } = options;
        const operators = options.operators
            ? options.operators
            : service.options?.whitelist;
        const filters = options.filters
            ? options.filters
            : service.options?.filters;
        const optionsForFilterQuery = {};
        if (operators) {
            optionsForFilterQuery.operators = operators;
        }
        if (filters) {
            optionsForFilterQuery.filters = filters;
        }
        if (typeof service?.filterQuery === "function") {
            return service.filterQuery({ query }, optionsForFilterQuery);
        }
        else {
            return plainFilterQuery(query, optionsForFilterQuery);
        }
    }
    return plainFilterQuery(query, options);
}
