"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.checkMulti = void 0;
const errors_1 = require("@feathersjs/errors");
const shouldSkip_1 = require("../utils/shouldSkip");
const isMulti_1 = require("../utils/isMulti");
function checkMulti() {
    return (context) => {
        if ((0, shouldSkip_1.shouldSkip)("checkMulti", context)) {
            return context;
        }
        const { service, method } = context;
        if (!service.allowsMulti || !(0, isMulti_1.isMulti)(context) || method === "find") {
            return context;
        }
        if (!service.allowsMulti(method)) {
            throw new errors_1.MethodNotAllowed(`Can not ${method} multiple entries`);
        }
        return context;
    };
}
exports.checkMulti = checkMulti;
