"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.filterQuery = void 0;
const adapter_commons_1 = require("@feathersjs/adapter-commons");
function filterQuery(query, options) {
    var _a, _b;
    query = query || {};
    options = options || {};
    if (options === null || options === void 0 ? void 0 : options.service) {
        const { service } = options;
        const operators = options.operators
            ? options.operators
            : (_a = service.options) === null || _a === void 0 ? void 0 : _a.whitelist;
        const filters = options.filters
            ? options.filters
            : (_b = service.options) === null || _b === void 0 ? void 0 : _b.filters;
        const optionsForFilterQuery = {};
        if (operators) {
            optionsForFilterQuery.operators = operators;
        }
        if (filters) {
            optionsForFilterQuery.filters = filters;
        }
        if (typeof (service === null || service === void 0 ? void 0 : service.filterQuery) === "function") {
            return service.filterQuery({ query }, optionsForFilterQuery);
        }
        else {
            return (0, adapter_commons_1.filterQuery)(query, optionsForFilterQuery);
        }
    }
    return (0, adapter_commons_1.filterQuery)(query, options);
}
exports.filterQuery = filterQuery;
