"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.markHookForSkip = void 0;
const pushSet_1 = require("./pushSet");
function markHookForSkip(hookName, type, context) {
    context = context || {};
    const params = context.params || {};
    const types = (Array.isArray(type)) ? type : [type];
    types.forEach(t => {
        const combinedName = (t === "all")
            ? hookName
            : `${type}:${hookName}`;
        (0, pushSet_1.pushSet)(params, ["skipHooks"], combinedName, { unique: true });
    });
    context.params = params;
    return context;
}
exports.markHookForSkip = markHookForSkip;
