"use strict";
// Kudos to @DaddyWarbucks! This is a cheeky copy of his awesome library: 'feathers-fletching'.
// Definitely check it out! https://daddywarbucks.github.io/feathers-fletching/overview.html
Object.defineProperty(exports, "__esModule", { value: true });
exports.shouldSkip = void 0;
const errors_1 = require("@feathersjs/errors");
const shouldSkip = (hookName, context) => {
    if (!context.params || !context.params.skipHooks) {
        return false;
    }
    const { skipHooks } = context.params;
    if (!Array.isArray(skipHooks)) {
        throw new errors_1.GeneralError("The `skipHooks` param must be an Array of Strings");
    }
    const { type } = context;
    if (skipHooks.includes(hookName)) {
        return true;
    }
    if (skipHooks.includes("all")) {
        return true;
    }
    if (type === "before") {
        return (skipHooks.includes(`before:${hookName}`) || skipHooks.includes("before"));
    }
    if (type === "after") {
        return (skipHooks.includes(`after:${hookName}`) || skipHooks.includes("after"));
    }
    if (type === "error") {
        return (skipHooks.includes(`error:${hookName}`) || skipHooks.includes("error"));
    }
    return false;
};
exports.shouldSkip = shouldSkip;
